﻿

interface  FlashServePkg.IFSChat {
	
	function onChatMsg(evt:Object);
		//debug("You should override this function. Ex: myFSSocket.onChatMsg = function() { ... }");
		/*
			Viene eseguita quando arriva un messaggio di chat
			Questo è il modo semplice di ricevere messaggi, ma un solo oggetto
			può ricevere i messaggi.
			
			TODO: eventi come key.addlistener per FSSocket così da poter avere
			tante finestre di chat indipendenti.
			
			placeholder: Overridare.
		
		*/
	
	function onSystem(evt:Object): Void ;
		/*
			Funzione per gestire i messaggi di sistema che non sono interni
			Overridare:
		*/
	
	function onChanCreated(evt:Object) ;
		//debug("You should override this function. Ex: myFSSocket.onChanCreated = function() { ... }");
		/*
			Viene eseguita quando si entra in un nuovo canale
			
			placeholder: Overridare.
		
		*/

	
	function onChanRemoved( evt:Object) ;
		//debug("You should override this function. Ex: myFSSocket.onChanRemoved = function() { ... }");
		/*
			Viene eseguita quando si entra in un nuovo canale
			
			placeholder: Overridare.
		
		*/

	
	function onChanInfo(evt:Object) :Void;
		/*
			Viene eseguita quando arrivano /chaninfo su un canale.
		
		*/
	
	function onNicklist(evt:Object) ;
		//debug("You should override this function. Ex: myFSSocket.onNicklist = function() { ... }");
		/*
			//TODO: aggiungere pure se uno è joinato o partato e distinguere dal caso
				in cui sia un /namelist
			Viene eseguita quando cambia la nicklist ("/join" o "/part" o "/quit")
			Overridare.
			
		*/

	//function onClose (): Void 
		/*
			Viene eseguita quando la connessione viene chiusa.
		*/

	
	function onError(evt:Object): Void ;
		/*
			Funzione di gestione degli errori.
			Overridare:
		*/
}