﻿import FlashServePkg.*;
import FlashServePkg.UI.*;


class Resizable {
	//Grafica del dialog:
	public var FSD_sx_up:MovieClip;
	public var FSD_up:MovieClip;
	public var FSD_dx_up:MovieClip;
	public var FSD_dx:MovieClip;
	public var FSD_dx_dn:MovieClip;
	public var FSD_dn:MovieClip;
	public var FSD_sx_dn:MovieClip;
	public var FSD_sx:MovieClip;
	public var FSD_fill:MovieClip;
	
	private var mc:MovieClip;
	
	function Resizable(mc:MovieClip) {
		this.mc = mc;
		
		if(this.mc.FSD_sx_up != undefined) { 
			//La grafica è dentro al movieclip
			trace("not loading");
		}
		else {
			trace("loading");
			this.mc.attachMovie('FSD_sx', 'FSD_sx', this.mc.getNextHighestDepth());
			this.mc.attachMovie('FSD_up', 'FSD_up', this.mc.getNextHighestDepth());
			this.mc.attachMovie('FSD_dx_up', 'FSD_dx_up', this.mc.getNextHighestDepth());
			this.mc.attachMovie('FSD_dx', 'FSD_dx', this.mc.getNextHighestDepth());
			this.mc.attachMovie('FSD_dx_dn', 'FSD_dx_dn', this.mc.getNextHighestDepth());
			this.mc.attachMovie('FSD_dn', 'FSD_dn', this.mc.getNextHighestDepth());
			this.mc.attachMovie('FSD_sx_dn', 'FSD_sx_dn', this.mc.getNextHighestDepth());
			this.mc.attachMovie('FSD_sx', 'FSD_sx', this.mc.getNextHighestDepth());
		}

		//TODO: servirebbe davvero una cosa del genere?
		/*if(this.mc.FSD_sx_up == undefined) {
			duplicateMovieClip(this.mc.FSD_dx_up || this.mc.FSD_dx_dn || this.mc.FSD_sx_dn, 'FSD_sx_up',
							   							this.mc.getNextHighestDepth());
		}*/

		this.setSize(this.mc._width, this.mc._height);
	}
	
	function set _width(w:Number):Void {
		//trace("set");
	}
	function get _width():Number {
		//trace("get");
		return 0;
	}
	
	// Imposta le dimensioni del Dialog:
	function setSize(w:Number, h:Number):Void {
		//Those can't be in the costructor becouse this.mc.FSD_* can change over time
		FSD_sx_up = (this.mc.FSD_sx_up == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_sx_up;
		FSD_up = (this.mc.FSD_up == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_up;
		FSD_dx_up = (this.mc.FSD_dx_up == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_dx_up;
		FSD_dx = (this.mc.FSD_dx == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_dx;
		FSD_dx_dn = (this.mc.FSD_dx_dn == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_dx_dn;
		FSD_dn = (this.mc.FSD_dn == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_dn;
		FSD_sx_dn = (this.mc.FSD_sx_dn == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_sx_dn;
		FSD_sx = (this.mc.FSD_sx == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_sx;
		FSD_fill = (this.mc.FSD_fill == undefined) ? new Object({_x: 0, _y:0, _width:0, _height:0}) : this.mc.FSD_fill;
	
		//L'anchor è in alto a sinistra:
		this.FSD_sx_up._x = 0;
		this.FSD_sx_up._y = 0;

		this.FSD_up._x = this.FSD_sx_up._width;
		this.FSD_up._y = 0;
		var FSD_up_width:Number = w - (this.FSD_sx_up._width + this.FSD_dx_up._width);
		FSD_up_width = (FSD_up_width < 0) ? 1 : FSD_up_width;
		this.FSD_up._width = FSD_up_width;
		
		this.FSD_dx_up._x = FSD_up_width + this.FSD_sx_up._width;
		this.FSD_dx_up._y = 0;
		
		this.FSD_dx._x = this.FSD_dx_up._x + this.FSD_dx_up._width - this.FSD_dx._width;
		this.FSD_dx._y = this.FSD_dx_up._height;
		var FSD_dx_height:Number = h - (this.FSD_dx_up._height + this.FSD_dx_dn._height);
		this.FSD_dx._height = (FSD_dx_height < 0) ? 1 : FSD_dx_height;
		
		this.FSD_dx_dn._x = this.FSD_dx._x + this.FSD_dx._width - this.FSD_dx_dn._width;
		this.FSD_dx_dn._y = this.FSD_dx._y + FSD_dx_height;
		
		this.FSD_sx._x = 0;
		this.FSD_sx._y = this.FSD_sx_up._height;
		var FSD_sx_height:Number = h - (this.FSD_sx_up._height + this.FSD_sx_dn._height);
		this.FSD_sx._height = (FSD_sx_height < 0) ? 1 : FSD_sx_height;
		
		this.FSD_sx_dn._x = 0;
		this.FSD_sx_dn._y = this.FSD_sx._y + FSD_sx_height;
		
		this.FSD_dn._x = 0 + this.FSD_sx_dn._width;
		this.FSD_dn._y = this.FSD_sx_dn._y + this.FSD_sx_dn._height - this.FSD_dn._height;
		var FSD_dn_width:Number = w - (this.FSD_sx_dn._width + this.FSD_dx_dn._width);
		this.FSD_dn._width = (FSD_dn_width < 0) ? 1 : FSD_dn_width;
		
		this.FSD_fill._x = this.FSD_sx_up._width;
		this.FSD_fill._width = FSD_up_width;
		
		this.FSD_fill._height = h - (this.FSD_up._height + this.FSD_dn._height);
		this.FSD_fill._y = 0 + this.FSD_up._height;
	}
}