﻿import FlashServePkg.UI.*;
import mx.transitions.Tween;
import mx.transitions.easing.*;

class ShowHide extends MovieClip {
	//La velocità in frames dell'effetto:
	public var showSpeed = 40;
	public var hideSpeed = 40;
	//Il tipo di tween per l'effetto (vedi: http://www.actionscript.org/tutorials/advanced/Tween-Easing_Classes_Documented/index.shtml ):
	public var showEaseType:Object = mx.transitions.easing.Strong.easeOut;
	public var hideEaseType:Object = mx.transitions.easing.Strong.easeIn;
	//I valori di alpha:
	public var maxAlpha = 100;
	public var minAlpha = 0;
	
	private var tween:Object;
	private var mc:MovieClip;
	
	//Solo per GLUE:
	function ShowHide(obj:MovieClip) {
		//TODO: questo serve per usarlo senza GLUE, togliere:
		if(obj == undefined) { this.mc = this; }
		else { this.mc = obj; }
	}
	
	// Mostra:
	function show() :Void {
		if(this.tween.isPlaying) { this.tween.stop(); }
		else { this.mc._visible = true; }
        this.tween = new mx.transitions.Tween(this.mc, "_alpha", this.showEaseType, 
														this.mc._alpha, this.maxAlpha, this.showSpeed, false);
	}
	
	//Nascondi:
	function hide() :Void {
		if(this.tween.isPlaying) { this.tween.stop(); }
        this.tween = new mx.transitions.Tween(this.mc, "_alpha", this.hideEaseType, 
														this.mc._alpha, this.minAlpha, this.hideSpeed, false);
		this.tween.addListener(this);
	}
	
	//questo evento viene sparato solo quando si sta scomparendo:
	function onMotionFinished() {
		//Almeno il testo dinamico scompare (e cmq dovrebbe essere più performante)
		this.mc._visible = false;
	}
}