﻿import FlashServePkg.*;
import FlashServePkg.UI.*;
/*

	TODO: sistemare la chat di gioco (bisogna modificare il server)
*/

class FlashServePkg.UI.lobby extends MovieClip {

public var lista:MovieClip;
public var animation:Boolean = true;
	
//VARIABILI PRIVATE:
public var FSSocket:Object;
private var gamesArray:Array;

	function lobby() {
		//TODO: SUL SERVER e qui: fare in modo che si disabiliti la ricezione dei
	    //			/gamecreated e simili
		this.lista.spaziamentoY = 3;
	}
	
	function setSocket(obj:Object): Void {
		/*
			Funzione che imposta il socket FlashServe da usare.
		*/
		this.FSSocket = obj;
		
		//Registra gli eventi:
		obj.addEventListener("onLobby", this);
		obj.addEventListener("onLogin", this);
	}
	public function redrawList(animation:Boolean) {
		//si può fare l'animazione o chiamando redrawList(true) 
		// 		o mettere obj.animation a true e aspettare un onLobby
		if(animation == undefined) { animation = this.animation; }
		this.lista.clearAll();
		
		var a:Array = this.gamesArray; 
		var l:Number = a.length;
		
		var obj:Object = new Object();
		for(var x=0; x < l; x++) {
			if(animation == true) { obj.conta = x*2; }
			obj.nome = a[x].nome;
			obj.numeri = a[x].users;
			//TODO: in futuro i numeri indicheranno il gioco
			obj.tipo = (a[x].gameType == 1) ? 'Scarabeo' : 'Gioco';
			if (a[x].limit != 0) { obj.numeri += "/" + a[x].limit; }
			this.lista.addObj(obj);
		}
		
		//Se si imposta animation rimane true solo per una volta:
		this.animation = false;
	}
	
	/* 	Function: setAnimation
		Se true verrà fatta l'animazione al prossimo refresh
	*/
	public function setAnimation(animation:Boolean) :Boolean {
		var prevAnimation:Boolean = this.animation;
		this.animation = animation;
		return prevAnimation;
	}
	//################### FUNZIONI INTERNE #############################
	
	//Eventi:
	
	function onLobby(Evt:Object): Void {
		//fa una copia locale dell'array
		this.gamesArray = Evt.gameslist.slice();
		this.redrawList();
	}
	
	
	
	function onLogin(Evt:Object): Void {
		//la prima volta fai l'animazione:
		this.animation = true;
		//chiedi la lista completa:
		this.FSSocket.listgames();
		
	}
}