﻿import FlashServePkg.*;

class FlashServePkg.UI.taskbar extends MovieClip {
public var button:String = "taskButton";
public var taskBtn:Object;
public var spaceBetween:Number = 0;
public var spanLeft:Number = 100;

//PRIVATE:
private var tasks:Array;
private var depth:Number = 10;

//Oggetti nel movieclip:
public var placeholder:MovieClip;

	function taskbar (button:String	) {
		if(button != undefined) { this.button = button; }
		
		if(this.placeholder == undefined) { trace("manca il placeholder"); }
		
		this.tasks = new Array();
		
	}
	
	public function addTaskButton(nome:String, tipo:String, btnInitObj:Object, rightAllign:Boolean ):Void {
		trace("si");
		//POSIZIONA IL TASTO NELLA TASKBAR:
		this.attachMovie("taskButton", "tbtn_" + nome, this.depth++, btnInitObj);
		this["tbtn_" + nome].setLabel(nome);
		
		var a:Array = this.tasks;
		var l:Number = a.length;
		var posX:Number = 0;
		//allineato a destra:
		if(rightAllign == true) {
			
			for(var x=0; x < l; x++) {
				posX += this["tbtn_" + a[x]].myWidth;
			}
			
			this["tbtn_" + nome]._x = this.spanLeft + posX + this.spaceBetween;
		}
		else {
		//allineato a sinistra:
			this["tbtn_" + nome]._x = this.spanLeft;
			
			for(var x=0; x < l; x++) {
				this["tbtn_" + a[x] ]._x += this["tbtn_" + nome].myWidth;
			}
		}
		
		this.tasks.push(nome);
	}
	
	public function loadTask(nome:String, tipo:String, url:String, loadListener:Object, btnInitObj:Object, rightAllign:Boolean): Void {
		this.createEmptyMovieClip("app_" + nome, this.depth++);
		
		//POSIZIONA L'APPLICAZIONE:
		this["app_" + nome]._lockroot = true;
		this["app_" + nome]._x = this.placeholder._x;
		this["app_" + nome]._y = this.placeholder._y;
		
		//POSIZIONA IL TASTO NELLA TASKBAR:
		this.addTaskButton(nome, tipo, btnInitObj, rightAllign);
		this["tbtn_" + nome].task = this["app_" + nome];
		this["tbtn_" + nome].taskName = nome;
		
		var loader:MovieClipLoader = new MovieClipLoader();
		loader.addListener(loadListener);
		loader.loadClip(url, this["app_" + nome]);

	}
	
	public function showApp(nome:String): Void {
		//mostra un'applicazione e nasconde le altre
		this["app_" + nome]._visible = true;
		
		var a:Array = this.tasks;
		var l:Number = a.length;
		for(var x=0; x < l; x++) {
			if(a[x] != nome) {
				this["app_" + a[x] ]._visible = false;
			}
		}
		
	}
}